from os import  environ
from typing import List
from ipaddress import ip_address
from toml import load as toml_load
from pprint import pprint


MULTI_FUNCTIONS = []


with open(environ.get('CONFIG_FILE', 'risotto.conf'), 'r') as fh:
    RISOTTO_CONFIG = toml_load(fh)


def _(s):
    return s


def multi_function(function):
    global MULTI_FUNCTIONS
    name = function.__name__
    if name not in MULTI_FUNCTIONS:
        MULTI_FUNCTIONS.append(name)
    return function


async def value_pprint(dico, config):
    pprint_dict = {}
    for path, value in dico.items():
        if await config.option(path).option.type() == 'password' and value:
            value = 'X' * len(value)
        pprint_dict[path] = value
    pprint(pprint_dict)


def load_zones(servers_json):
    zones = servers_json['zones']
    for host_name, hosts in servers_json['hosts'].items():
        for server_name, server in hosts['servers'].items():
            server_zones = server['informations']['zones_name']
            for idx, zone_name in enumerate(server_zones):
                zone = zones[zone_name]
                zone.setdefault('hosts', {})
                zone['hosts'][server_name] = _get_ip(server_name, zone)


def _get_ip(server_name: str,
            zone: dict,
            ) -> str:
    # FIXME make a cache, machine should not change IP
    server_index = len(zone['hosts'])
    return str(ip_address(zone['start_ip']) + server_index)
